<template>
  <div>
    <rui-modal v-if="observationId && observation" :caption="$t('js.observations.one_observation')" :acceptable="false" @close="closeDetailsModal('observation')">
      <gp-observation-timeline-entry :observation="observation" :editable="false" hide-icon opened />
    </rui-modal>

    <rui-modal v-if="taskId && task" :caption="$t('js.tasks.one_task')" :acceptable="false" @close="closeDetailsModal('task')">
      <gp-task-timeline-entry :task="task" class="-mbd" hide-icon opened />
    </rui-modal>
  </div>
</template>

<script>
import RuiModal from '@experiments-labs/rise_ui/src/components/Modal/Modal.vue'

import GpObservationTimelineEntry from './DataDisplay/Observation/TimelineEntry.vue'
import GpTaskTimelineEntry from './DataDisplay/Task/TimelineEntry.vue'

/**
 * Display modals depending on the query string.
 *
 * The goal here is to handle direct links to elements, like the ones received in emails.
 *
 * @noPlayground
 */
export default {
  name: 'GpDetailsFromRoute',
  components: { GpObservationTimelineEntry, GpTaskTimelineEntry, RuiModal },
  data () {
    return {
      loading: false,
      loadingError: null,
      observationId: null,
      taskId: null,
    }
  },
  computed: {
    observation () { return this.$store.getters.observation(this.observationId) },
    task () { return this.$store.getters.task(this.taskId) },
  },
  methods: {
    closeDetailsModal (type) {
      const query = { ...this.$route.query }
      if (type === 'observation') {
        delete query.show_observation
        this.observationId = null
      } else if (type === 'task') {
        delete query.show_task
        this.taskId = null
      }

      this.$router.push({ query })
    },
    checkQueryString () {
      if (this.$route.query.show_observation) {
        this.showObservation(parseInt(this.$route.query.show_observation, 10))
      }
      if (this.$route.query.show_task) {
        this.showTask(parseInt(this.$route.query.show_task, 10))
      }
    },
    loadData (storeAction, id, onSuccess) {
      this.loading = true
      this.loadingError = null
      this.$store.dispatch(storeAction, id)
        .then(onSuccess)
        .catch((error) => { this.loadingError = error })
        .then(() => { this.loading = false })
    },
    showObservation (id) {
      this.loadData('loadObservation', id, () => { this.observationId = id })
    },
    showTask (id) {
      this.loadData('loadTask', id, () => { this.taskId = id })
    },
  },
  created () {
    this.checkQueryString()
  },
  watch: {
    $route () {
      this.checkQueryString()
    },
  },
}
</script>
